package http

import (
	"fmt"
	"net/http"

	"github.com/gin-gonic/gin"
	"github.com/google/uuid"
	"github.com/pressly/goose/v3"
)

type AdminData struct {
}

func (h *Handler) admin(c *gin.Context) {
	d := AdminData{}

	c.HTML(http.StatusOK, "admin.html", d)
}

func (h *Handler) clearDatabase(c *gin.Context) {
	d := AdminData{}

	if err := goose.Reset(h.Service.DB, "schema"); err != nil {
		c.AbortWithError(http.StatusInternalServerError, err)
	}

	if err := goose.Up(h.Service.DB, "schema"); err != nil {
		c.AbortWithError(http.StatusInternalServerError, err)
	}

	c.HTML(http.StatusOK, "admin.html", d)
}

type SettingsData struct {
	AlwaysNeededData
}

func (h *Handler) settings(c *gin.Context) {
	d := SettingsData{
		c.MustGet("data").(AlwaysNeededData),
	}

	c.HTML(http.StatusOK, "settings.html", d)
}

func (h *Handler) clearBudget(c *gin.Context) {
	budgetID := c.Param("budgetid")
	budgetUUID, err := uuid.Parse(budgetID)
	if err != nil {
		c.Redirect(http.StatusTemporaryRedirect, "/login")
		return
	}

	rows, err := h.Service.DeleteAllAssignments(c.Request.Context(), budgetUUID)
	if err != nil {
		c.AbortWithError(http.StatusInternalServerError, err)
		return
	}

	fmt.Printf("Deleted %d assignments\n", rows)

	rows, err = h.Service.DeleteAllTransactions(c.Request.Context(), budgetUUID)
	if err != nil {
		c.AbortWithError(http.StatusInternalServerError, err)
		return
	}

	fmt.Printf("Deleted %d transactions\n", rows)
}

func (h *Handler) cleanNegativeBudget(c *gin.Context) {
	/*budgetID := c.Param("budgetid")
	budgetUUID, err := uuid.Parse(budgetID)
	if err != nil {
		c.Redirect(http.StatusTemporaryRedirect, "/login")
		return
	}*/

	/*min_date, err := h.Service.GetFirstActivity(c.Request.Context(), budgetUUID)
	date := getFirstOfMonthTime(min_date)
	for {
		nextDate := date.AddDate(0, 1, 0)
		params := postgres.GetCategoriesWithBalanceParams{
			BudgetID: budgetUUID,
			ToDate:   nextDate,
			FromDate: date,
		}
		categories, err := h.Service.GetCategoriesWithBalance(c.Request.Context(), params)
		if err != nil {
			c.AbortWithError(http.StatusInternalServerError, err)
			return
		}

		for _, category := range categories {
			available := category.Available.GetFloat64()
			if available >= 0 {
				continue
			}
			var negativeAvailable postgres.Numeric
			negativeAvailable.Set(-available)
			createAssignment := postgres.CreateAssignmentParams{
				Date:       nextDate.AddDate(0, 0, -1),
				Amount:     negativeAvailable,
				CategoryID: category.ID,
			}
			h.Service.CreateAssignment(c.Request.Context(), createAssignment)
		}

		if nextDate.Before(time.Now()) {
			date = nextDate
		} else {
			break
		}
	}*/

}
